
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class Main {

    protected int nodesCnt;
    protected int centralNode;
    protected int[][] edges = new int[1001][1000];
    protected int[][] edgesPrice = new int[1001][1000];
    protected int[] edgesCnt = new int[1001];
    
    public static void main(String[] args) throws Exception {
        Main p = new Main();
        p.run();
    }
    
    protected void run() throws Exception {
        while (input.ready()) {
            this.nodesCnt = this.nextInt();
            this.centralNode = this.nextInt();
            
            for (int i = 1; i <= nodesCnt; i++) {
                edgesCnt[i] = 0;
            }
            
            for (int i = 0; i < this.nodesCnt - 1; i++) {
                int b = this.nextInt();
                int e = this.nextInt();
                int price = this.nextInt();
                edges[b][edgesCnt[b]] = e;
                edges[e][edgesCnt[e]] = b;
                edgesPrice[b][edgesCnt[b]] = price;
                edgesPrice[e][edgesCnt[e]] = price;
                edgesCnt[b]++;
                edgesCnt[e]++;
            }
            System.out.println(getPrice(centralNode, -10, -10));
        }
    }
    
    protected int getPrice(int node, int parent, int parentPrice) {
        if (edgesCnt[node] == 1 && parentPrice != -10) {
            return edgesPrice[node][0];
        }
        int sum = 0;
        for (int i = 0; i < edgesCnt[node]; i++) {
            if (edges[node][i] != parent) {
                sum += getPrice(edges[node][i], node, edgesPrice[node][i]);
            }
            if (sum >= parentPrice && parentPrice != -10) {
                return parentPrice;
            }
        }
        return sum;
        /*int price = 0;
        for (int i = 0; i < edgesCnt[node]; i++) {
            if (edges[node][i] != parent) {
                closeMePrice += edgesPrice[node][i];
                closeChildrenPrice += getPrice(edges[node][i], node);
            }
        }
        if (closeChildrenPrice == 0) {
            return closeMePrice;
        }
        return Math.min(closeMePrice, closeChildrenPrice);*/
    }
    
    StringTokenizer st = new StringTokenizer("");
    BufferedReader input = new BufferedReader(new InputStreamReader(System.in));

    public String nextToken() throws Exception {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(input.readLine());
        }
        return st.nextToken();
    }
    
    public int nextInt() throws Exception {
        return Integer.parseInt(nextToken());
    }
    
    public String nextLine() throws Exception {
        return input.readLine();
    }
    
}
